"use strict";
/**
 *
 * @param pagedApi
 * @param collect Array function(result)
 * @returns function(options, callback)
 */
function allCursors(pagedApi, collect) {
  var all = function (options, callback) {
    if (options && !callback) {
      callback = options;
      options = undefined;
    }
    if (options && options.hasOwnProperty("next_cursor") && options.next_cursor === undefined) {
      return callback([]);
    }
    pagedApi(options, function (error, result) {
      if (error) {
        console.error(error);
        callback([]);
      } else {
        all(Object.assign({max_results: 500}, options, {next_cursor: result.next_cursor}), function(collected){
          callback(collect(result).concat(collected));
        });
      }
    })
  };
  return all;
}

//
// var cloudinary = require('../cloudinary').v2;
//
// var r;
// var listAllResources = allCursors(cloudinary.api.resources, (result)=> result.resources);
//
// listAllResources((resources)=> {console.log("got " + resources.length + " resources");r = resources;});
//
// var listAllTransformations= allCursors(cloudinary.api.transformations, (result)=> result.transformations);
// listAllTransformations(function (transformations) {
//   console.log("got " + transformations.length + " transformations");
//   r = transformations;
// });
//

module.exports = allCursors;